<script lang="ts">
  import { send } from "./cardCrossfade";
  import CardBack from "./CardBack.svelte";

  export let size: number;
  export let deck: Card[];

  $: cards = deck.slice(-10);
</script>

<div class="deck">
  {#each cards as card, idx (card)}
    <div style={`transform: translate(-${idx * 0.12}em, -${idx * 0.12}em);`}>
      <div out:send={{ key: card }}>
        <CardBack />
      </div>
      {#if idx === cards.length - 1}
        <div class="size-wrapper">
          <div class="size">× {size}</div>
        </div>
      {/if}
    </div>
  {/each}
</div>

<style>
  .deck {
    position: relative;
  }
  .deck > *:first-child {
    position: relative;
    height: 14em;
  }
  .deck > * {
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
  }

  .size-wrapper {
    top: -14em;
    position: relative;
    height: 14em;
    width: 10em;
  }
  .size {
    font-size: 2em;

    background-color: whitesmoke;
    padding: 0 0.33em;
    border-radius: 0.25em;

    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    white-space: nowrap;
    overflow-x: visible;
    display: flex;

    align-items: center;
  }
</style>
